//---------------------------------------------------------------------------

//   ,    10- 
//       


#pragma hdrstop
 //   

#include "ltr\\include\\ltr212api.h"
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <conio.h>

#define ACQ_BLOCKS_QNT (2) //   ,     
#define TOTAL_BLOCKS_QNT (10) //    
#define POINTS_PER_CHANNEL (256) //        .
#define CHANNELS_QNT (4) //   

TLTR212 hltr212;  //    
HANDLE AcqThreadHnd;   //    

LPCSTR ErrorString;    //      

//  ,    
double voltage[ACQ_BLOCKS_QNT][CHANNELS_QNT*POINTS_PER_CHANNEL];

static volatile int RunFlag = 0; // , ,    
 //    .
static volatile int BlockReady[ACQ_BLOCKS_QNT];
//     
static DWORD WINAPI AcqThread (LPVOID param);

//        
int oem_printf(const char *s, ...);

//---------------------------------------------------------------------------
int oem_printf(const char *s, ...)
{
 char str[1024];
 va_list list;
 va_start(list, s);
 vsprintf(str, s, list);
 va_end(list);
 CharToOem(str, str);
 return printf(str);
}

//    
static DWORD WINAPI AcquireThread(LPVOID param)
{
 int i;
 int err=0;
 INT DataCntr=0;
 DWORD data[2*POINTS_PER_CHANNEL*CHANNELS_QNT];  //    
 DWORD to;          //   
 INT BlockCntr=0;   //  

 INT size; //   
 DWORD ExitCode;

/********* ,      . *******/

 //     
 for(i=0;i<ACQ_BLOCKS_QNT;i++)
    BlockReady[i]=0;

 //   
 err=LTR212_Start(&hltr212);
 if(err)
  { //       
    ErrorString=LTR212_GetErrorString(err);
    oem_printf("%s", (CHAR *) ErrorString);
    LTR212_Stop(&hltr212);
    RunFlag=0;
  }

  /*         ,
        .    
       2, ..   - 32     
         */

  size=2*POINTS_PER_CHANNEL*CHANNELS_QNT;
  //     
  to=LTR212_CalcTimeOut(&hltr212, POINTS_PER_CHANNEL);

  //     
  while(RunFlag)
  {
   //   (size)     ,
   // ..    - LTR212_ProcessData()
   //   
   size=2*POINTS_PER_CHANNEL*CHANNELS_QNT;

   //  
   DataCntr=LTR212_Recv(&hltr212, data, NULL, size, to);
   if(DataCntr!=size)  //  
    {
     RunFlag=0;
     if(DataCntr>=0)
       oem_printf("!   ,   !\n");
     else
       {
        err=DataCntr;
        ErrorString=LTR212_GetErrorString(err);
        oem_printf("%s\n", ErrorString);
       }
       break;
     } //  if(DataCntr!=size)

     //         
     err=LTR212_ProcessData(&hltr212, data, voltage[BlockCntr], &size, 1);
     if(err)
      {
       ErrorString=LTR212_GetErrorString(err);
       oem_printf("%s\n", ErrorString);
       RunFlag=0;
       break;
      }

      BlockReady[BlockCntr]=1;

      BlockCntr++;
      if(BlockCntr>=ACQ_BLOCKS_QNT)
        BlockCntr=0;
  } //  while(RunFlag)

  RunFlag=0; //    
  err=LTR212_Stop(&hltr212); //   
  if(err)
  {
    ErrorString=LTR212_GetErrorString(err);
    oem_printf("%s\n", (CHAR *) ErrorString);
  }

  //   
  ExitThread(ExitCode);
  return 0;
}

#pragma argsused
int main(int argc, char* argv[])
{
DWORD AcqThreadId;
DWORD ThreadSatus;

INT TotalBlockCntr;

INT err;                 //     
INT i;                   //      
CHAR *BiosVersion;       //      
CHAR *BiosDate;          //       
CHAR *SerialNum;         //       
CHAR *ModuleName;        //      

int         Channel;
FILE       *DataFile;
const char FileName[] = "ltr212_data.bin";

int BlockCntr=0;

/*     .
         . */

 oem_printf("%s", "   \n");
 err=LTR212_Init(&hltr212);

 if(err)
 {
 ErrorString=LTR212_GetErrorString(err);
 oem_printf("%s\n", (CHAR *) ErrorString);
 goto End;
 //return(err);
  }
 else
  oem_printf("LTR212_Init()->OK\n");



//     .      -  
//      ;
//   - 1;
//      - "C:\\prj\\ltr\\LTR-212\\LTR212-ADSP\\ltr212.bio"

err=LTR212_Open(&hltr212, SADDR_DEFAULT, SPORT_DEFAULT, "", CC_MODULE1,
                                  "ltr212.bio");
 if(err)
 {
  ErrorString=LTR212_GetErrorString(err);
  oem_printf("%s\n", (CHAR *) ErrorString);
  goto End;
  //return(err);
  }
 else
  oem_printf("LTR212_Open()->OK\n\n");

oem_printf(" : %s\n", hltr212.ModuleInfo.Name);
oem_printf(" : %s\n", hltr212.ModuleInfo.BiosVersion);
oem_printf("  : %s\n", hltr212.ModuleInfo.BiosDate);
oem_printf("  : %s\n\n", hltr212.ModuleInfo.Serial);

 //        

hltr212.size=sizeof(TLTR212);  //  
hltr212.AcqMode=1;                  // 4-   
hltr212.UseClb=0;                   //     
hltr212.UseFabricClb=0/*1*/;        //     . .
hltr212.LChQnt=4;                   //    - 4
hltr212.REF=1;                      //    5 .
hltr212.AC=0;                      //    

//  4  
//       - +/- 80 
hltr212.LChTbl[0]=LTR212_CreateLChannel(1,3);
hltr212.LChTbl[1]=LTR212_CreateLChannel(2,3);
hltr212.LChTbl[2]=LTR212_CreateLChannel(3,3);
hltr212.LChTbl[3]=LTR212_CreateLChannel(4,3);



//      
err=LTR212_SetADC(&hltr212);
if(err)
 {
 ErrorString=LTR212_GetErrorString(err);
 LTR212_Close(&hltr212);
 oem_printf("%s\n", (CHAR *) ErrorString);
 goto End;
  }
 else
  oem_printf("LTR212_SetADC()->OK\n\n");

oem_printf(" 4-   .\n");
oem_printf("   - 4.\n");
oem_printf("     - +/-80 .\n");
oem_printf("   .\n");
oem_printf("    5 .\n\n");

 DataFile = fopen(FileName, "wb");
 if(DataFile==NULL)
  {
   oem_printf("%s\n","  !");
   LTR212_Close(&hltr212);
   goto End;
  }

RunFlag = 1;

/*******      ***************/

//  
AcqThreadHnd=CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)AcquireThread,
                        NULL, CREATE_SUSPENDED, (LPDWORD) &AcqThreadId);

if(AcqThreadHnd==NULL)
{
 oem_printf("%s\n","    !\n");
 LTR212_Close(&hltr212);
 goto End;
}

//  
ResumeThread(AcqThreadHnd);

oem_printf("   \n");

TotalBlockCntr  = 0; //        

while(RunFlag) //      (..  )
{
 if(BlockReady[BlockCntr]) //     ,  
                           //  
 {
   TotalBlockCntr++;  //    -   .
   fwrite(voltage[BlockCntr], sizeof voltage[0][0],
   CHANNELS_QNT*POINTS_PER_CHANNEL, DataFile);
   oem_printf("%d- %s\n",TotalBlockCntr, "      ");
   BlockReady[BlockCntr]=0;

   BlockCntr++;

   if(BlockCntr>=2)
    BlockCntr=0;

    if (TotalBlockCntr >= TOTAL_BLOCKS_QNT)
    {
     oem_printf(">>    .\n");
     RunFlag = 0;
     }
    } //  if(BlockReady[BlockCntr])
  }    //  while(RunFlag)

//     
  WaitForSingleObject(AcqThreadHnd, INFINITE);
  GetExitCodeThread(AcqThreadHnd, &ThreadSatus);

  CloseHandle(AcqThreadHnd);
  oem_printf("   .\n");

  //  
  fclose(DataFile);
  oem_printf("    .\n");


End:
oem_printf(">>     \n");
    while(!kbhit())
        continue;


        return 0;
}
//---------------------------------------------------------------------------
